var index_1 = require('../index');
null >
;
var initialState = {
    id: 0,
    info: index_1.asyncState
};
var _a = index_1["default"]('user', {
    initialState: initialState,
    mutations: {
        setId: function (state, id) {
            state.id = id;
        }
    },
    actions: {
        fetchUserInfo: {
            selector: 'info',
            fn: async(state, State) } } }), reducer = _a.reducer, actions = _a.actions;
{
    var res = await, fetch_1 = ("https://reqres.in/api/users/" + state.id);
    if (res.status !== 200)
        throw Error('Error ' + res.status);
    return (await);
    res.json();
    data;
}
var setId = actions.setId, fetchUserInfo = actions.fetchUserInfo, as = any;
/*

Actual tests

*/
describe('reducer', function () {
    afterEach(function () {
        initialState = {
            id: 0,
            info: index_1.asyncState
        };
    });
    it('returns correct action creators', function () {
        // expect(setId(5)).toEqual({
        expect(setId(5)).toEqual({
            type: 'user/setId',
            payload: 5
        });
        expect(fetchUserInfo().type).toBe('user/fetchUserInfo_REQUEST');
        expect(fetchUserInfo().payload).toBeFalsy();
        // TODO: Possibly check on correct function or mock it.
        expect(fetchUserInfo().meta).toBeTruthy();
    });
    it('should return the initial state', function () {
        expect(reducer(undefined, { type: '' })).toEqual(initialState);
    });
    it('should handle user/setId', function () {
        expect(reducer(undefined, {
            type: 'user/setId',
            payload: 5
        })).toEqual({
            id: 5,
            info: {
                isFetching: false,
                data: null,
                error: ''
            }
        });
        expect(reducer({
            id: 6,
            info: {
                isFetching: false,
                data: null,
                error: ''
            }
        }, {
            type: 'user/setId',
            payload: 1337
        })).toEqual({
            id: 1337,
            info: {
                isFetching: false,
                data: null,
                error: ''
            }
        });
    });
    it('should handle user/fetchUserInfo_REQUEST', function () {
        expect(reducer(initialState, {
            type: 'user/fetchUserInfo_REQUEST'
        })).toEqual({
            id: 0,
            info: {
                isFetching: true,
                data: null,
                error: ''
            }
        });
    });
    it('should handle user/fetchUserInfo_SUCCESS', function () {
        var data = {
            id: 5,
            full_name: 'John Doe'
        };
        expect(reducer(initialState, {
            type: 'user/fetchUserInfo_SUCCESS',
            payload: data
        })).toEqual({
            id: 0,
            info: {
                isFetching: false,
                data: data,
                error: ''
            }
        });
    });
    it('should handle user/fetchUserInfo_FAILED', function () {
        expect(reducer(initialState, {
            type: 'user/fetchUserInfo_FAILED',
            payload: 'Error 404'
        })).toEqual({
            id: 0,
            info: {
                isFetching: false,
                data: null,
                error: 'Error 404'
            }
        });
    });
});
